<html>
<head>
<title>OGRE: Ogre::Matrix4 Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a></div>
<h1>Ogre::Matrix4 Class Reference</h1><!-- doxytag: class="Ogre::Matrix4" -->Class encapsulating a standard 4x4 homogenous matrix.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1Matrix4-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#bde37761a7b38997925b6805f6494f72">Matrix4</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Default constructor.  <a href="#bde37761a7b38997925b6805f6494f72"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#91cac2ee0f0e8bd582c24db497afcd21">Matrix4</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m00, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m01, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m02, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m03, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m10, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m11, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m12, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m13, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m20, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m21, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m22, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m23, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m30, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m31, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m32, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> m33)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#8ae0763e439e87045b1ce46dca2c279c">Matrix4</a> (const <a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;m3x3)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a standard 4x4 transformation matrix with a zero translation part from a rotation/scaling 3x3 matrix.  <a href="#8ae0763e439e87045b1ce46dca2c279c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#af7dc461a266459ab6916e7f97991969">Matrix4</a> (const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;rot)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a standard 4x4 transformation matrix with a zero translation part from a rotation/scaling <a class="el" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>.  <a href="#af7dc461a266459ab6916e7f97991969"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a996041c004dbfd5629120299ee0cb6f">operator[]</a> (size_t iRow)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> *const&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#4d1282bf2eae1c961e7adc14f521c1af">operator[]</a> (size_t iRow) const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#a61f91e4084cdc0adce4eb489a8f9898">concatenate</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m2) const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#0e1e208f7aa1283990d70ae7073ca439">operator *</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m2) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Matrix concatenation using '*'.  <a href="#0e1e208f7aa1283990d70ae7073ca439"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#c1de0742f69e162e1ffc3a1aa18c3343">operator *</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Vector transformation using '*'.  <a href="#c1de0742f69e162e1ffc3a1aa18c3343"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Vector4.html">Vector4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#95d402f87f878b8924a769dad7385156">operator *</a> (const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;v) const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Plane.html">Plane</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#d2374f86f6315aadbbe14ce743bc99e9">operator *</a> (const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;p) const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#c0c54ddc64f9b832ab2656f514060fbb">operator+</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m2) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Matrix addition.  <a href="#c0c54ddc64f9b832ab2656f514060fbb"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#6c698c19379d5b4d2ff6e5dd186ad76c">operator-</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m2) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Matrix subtraction.  <a href="#6c698c19379d5b4d2ff6e5dd186ad76c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#5eb73fdc4084eed850221ed14f558ff2">operator==</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m2) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Tests 2 matrices for equality.  <a href="#5eb73fdc4084eed850221ed14f558ff2"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#67d3ae14b6b68e6824f1a91d99da16f8">operator!=</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m2) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Tests 2 matrices for inequality.  <a href="#67d3ae14b6b68e6824f1a91d99da16f8"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#5c5f37c501d49692728909d11dd8c1de">operator=</a> (const <a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;mat3)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Assignment from 3x3 matrix.  <a href="#5c5f37c501d49692728909d11dd8c1de"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#e141496dd80a027493cfc0bea3952a4d">transpose</a> (void) const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#af08a89733aa192a0d9e414e8b18ccf1">setTrans</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets the translation transformation part of the matrix.  <a href="#af08a89733aa192a0d9e414e8b18ccf1"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#928e9a44acf0f5a998392b272b117a4f">getTrans</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Extracts the translation transformation part of the matrix.  <a href="#928e9a44acf0f5a998392b272b117a4f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#fb53c4fa6548001260d77dc283e3652f">makeTrans</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Builds a translation matrix.  <a href="#fb53c4fa6548001260d77dc283e3652f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#87f478c5d19a10a371b736108e0b5e5f">makeTrans</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> tx, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> ty, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> tz)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#754a168ea4d55d40c9a24ef33eb41c95">setScale</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets the scale part of the matrix.  <a href="#754a168ea4d55d40c9a24ef33eb41c95"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#7c32a3b5d7675181995e917f66c18b69">extract3x3Matrix</a> (<a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;m3x3) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Extracts the rotation / scaling part of the Matrix as a 3x3 matrix.  <a href="#7c32a3b5d7675181995e917f66c18b69"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#e66aaed3ab33c1f2a9862bc21dde0608">extractQuaternion</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Extracts the rotation / scaling part as a quaternion from the Matrix.  <a href="#e66aaed3ab33c1f2a9862bc21dde0608"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#1cbc315fd1f84a20c9a7d42e8f5db9da">operator *</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> scalar) const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#2570c4903858248e80bc6f34571c141a">adjoint</a> () const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#7e14122cbf6856b9701142cb6580aaa1">determinant</a> () const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#8879acb17e3029cf8bc2796b29ed8470">inverse</a> () const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#283bf568c924a673a1467c428d4b969d">makeTransform</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;position, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;scale, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;orientation)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Building a <a class="el" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a> from orientation / scale / position.  <a href="#283bf568c924a673a1467c428d4b969d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#4e5949d1d1004070660f31036ee69523">makeInverseTransform</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;position, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;scale, const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;orientation)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Building an inverse <a class="el" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a> from orientation / scale / position.  <a href="#4e5949d1d1004070660f31036ee69523"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#582b20b912ed7d7f8f179505dfbe7a4e">isAffine</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Check whether or not the matrix is affine matrix.  <a href="#582b20b912ed7d7f8f179505dfbe7a4e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#48cec18b03b16a9161d1c95b493a38a4">inverseAffine</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the inverse of the affine matrix.  <a href="#48cec18b03b16a9161d1c95b493a38a4"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#854210ca8faa1380f447e552c1d34191">concatenateAffine</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m2) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Concatenate two affine matrix.  <a href="#854210ca8faa1380f447e552c1d34191"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#fcd6dae51beb8283338ad52ac63c86fb">transformAffine</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">3-D Vector transformation specially for affine matrix.  <a href="#fcd6dae51beb8283338ad52ac63c86fb"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Vector4.html">Vector4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#30bacec4331db3d61f8a43a0d8596595">transformAffine</a> (const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;v) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">4-D Vector transformation specially for affine matrix.  <a href="#30bacec4331db3d61f8a43a0d8596595"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#88fb90dffc0216a0a59bf19fad4eeace">getTrans</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets a translation matrix.  <a href="#88fb90dffc0216a0a59bf19fad4eeace"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#3eedf9b0ea1245683a20f2e98ebd7e42">getTrans</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> t_x, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> t_y, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> t_z)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets a translation matrix - variation for not using a vector.  <a href="#3eedf9b0ea1245683a20f2e98ebd7e42"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#dfddc3e047c6052647ebfa5ddb3fbe13">getScale</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets a scale matrix.  <a href="#dfddc3e047c6052647ebfa5ddb3fbe13"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#5bac8a5777be6cf9af08c98de120d562">getScale</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> s_x, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> s_y, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> s_z)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets a scale matrix - variation for not using a vector.  <a href="#5bac8a5777be6cf9af08c98de120d562"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#838ac3cb744a01a39dfe35c61e942d7a">ZERO</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">static const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#f2f61127dd1911c9ac2b4cbc0b4f3668">IDENTITY</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">static const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#08a798c0d8c8290dbc0287ca6561f549">CLIPSPACE2DTOIMAGESPACE</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Useful little matrix which takes 2D clipspace {-1, 1} to {0,1} and inverts the Y.  <a href="#08a798c0d8c8290dbc0287ca6561f549"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap>union {</td></tr>

<tr><td class="memItemLeft" nowrap>&nbsp;&nbsp;&nbsp;<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;&nbsp;&nbsp;<a class="el" href="classOgre_1_1Matrix4.html#949708616d61b1c520d04bd9b0577324">m</a> [4][4]</td></tr>

<tr><td class="memItemLeft" nowrap>&nbsp;&nbsp;&nbsp;<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;&nbsp;&nbsp;<a class="el" href="classOgre_1_1Matrix4.html#0d9aaf75aa94b65f4ec5fe1afb0cf4d1">_m</a> [16]</td></tr>

<tr><td class="memItemLeft" nowrap valign="top">};&nbsp;</td><td class="memItemRight" valign="bottom"></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The matrix entries, indexed by [row][col].  <a href="#64e62f0586dd8550fd6b0fa0b6d200b5"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Friends</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">_OgreExport friend <br>
std::ostream &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Matrix4.html#2adb0cd285959c5d2ef1c2e32937d1eb">operator&lt;&lt;</a> (std::ostream &amp;o, const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;<a class="el" href="classOgre_1_1Matrix4.html#949708616d61b1c520d04bd9b0577324">m</a>)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Function for writing to a stream.  <a href="#2adb0cd285959c5d2ef1c2e32937d1eb"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Class encapsulating a standard 4x4 homogenous matrix. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>OGRE uses column vectors when applying matrix multiplications, This means a vector is represented as a single column, 4-row matrix. This has the effect that the tranformations implemented by the matrices happens right-to-left e.g. if vector V is to be transformed by M1 then M2 then M3, the calculation would be M3 * M2 * M1 * V. The order that matrices are concatenated is vital since matrix multiplication is not cummatative, i.e. you can get a different result if you concatenate in the wrong order. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>The use of column vectors and right-to-left ordering is the standard in most mathematical texts, and id the same as used in OpenGL. It is, however, the opposite of Direct3D, which has inexplicably chosen to differ from the accepted standard and uses row vectors and left-to-right matrix multiplication. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>OGRE deals with the differences between D3D and OpenGL etc. internally when operating through different render systems. OGRE users only need to conform to standard maths conventions, i.e. right-to-left matrix multiplication, (OGRE transposes matrices it passes to D3D to compensate). </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>The generic form M * V which shows the layout of the matrix entries is shown below: <pre>
                [ m[0][0]  m[0][1]  m[0][2]  m[0][3] ]   {x}
                | m[1][0]  m[1][1]  m[1][2]  m[1][3] | * {y}
                | m[2][0]  m[2][1]  m[2][2]  m[2][3] |   {z}
                [ m[3][0]  m[3][1]  m[3][2]  m[3][3] ]   {1}
            </pre> </dd></dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00073">73</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="bde37761a7b38997925b6805f6494f72"></a><!-- doxytag: member="Ogre::Matrix4::Matrix4" ref="bde37761a7b38997925b6805f6494f72" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::Matrix4::Matrix4           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Default constructor. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>It does <b>NOT</b> initialize the matrix for efficiency. </dd></dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00086">86</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="91cac2ee0f0e8bd582c24db497afcd21"></a><!-- doxytag: member="Ogre::Matrix4::Matrix4" ref="91cac2ee0f0e8bd582c24db497afcd21" args="(Real m00, Real m01, Real m02, Real m03, Real m10, Real m11, Real m12, Real m13, Real m20, Real m21, Real m22, Real m23, Real m30, Real m31, Real m32, Real m33)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::Matrix4::Matrix4           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m00</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m01</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m02</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m03</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m10</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m11</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m12</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m13</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m20</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m21</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m22</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m23</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m30</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m31</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m32</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>m33</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00090">90</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="8ae0763e439e87045b1ce46dca2c279c"></a><!-- doxytag: member="Ogre::Matrix4::Matrix4" ref="8ae0763e439e87045b1ce46dca2c279c" args="(const Matrix3 &amp;m3x3)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::Matrix4::Matrix4           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>m3x3</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a standard 4x4 transformation matrix with a zero translation part from a rotation/scaling 3x3 matrix. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00117">117</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="af7dc461a266459ab6916e7f97991969"></a><!-- doxytag: member="Ogre::Matrix4::Matrix4" ref="af7dc461a266459ab6916e7f97991969" args="(const Quaternion &amp;rot)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::Matrix4::Matrix4           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rot</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a standard 4x4 transformation matrix with a zero translation part from a rotation/scaling <a class="el" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00126">126</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="classOgre_1_1Quaternion.html#7e6b9955074bf92c2b778dc0307769a2">Ogre::Quaternion::ToRotationMatrix()</a>.</p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="a996041c004dbfd5629120299ee0cb6f"></a><!-- doxytag: member="Ogre::Matrix4::operator[]" ref="a996041c004dbfd5629120299ee0cb6f" args="(size_t iRow)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>* Ogre::Matrix4::operator[]           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>iRow</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00135">135</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="4d1282bf2eae1c961e7adc14f521c1af"></a><!-- doxytag: member="Ogre::Matrix4::operator[]" ref="4d1282bf2eae1c961e7adc14f521c1af" args="(size_t iRow) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>* const Ogre::Matrix4::operator[]           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>iRow</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00141">141</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="a61f91e4084cdc0adce4eb489a8f9898"></a><!-- doxytag: member="Ogre::Matrix4::concatenate" ref="a61f91e4084cdc0adce4eb489a8f9898" args="(const Matrix4 &amp;m2) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::concatenate           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>m2</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00147">147</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h-source.html#l00078">m</a>.</p>

</div>
</div><p>
<a class="anchor" name="0e1e208f7aa1283990d70ae7073ca439"></a><!-- doxytag: member="Ogre::Matrix4::operator *" ref="0e1e208f7aa1283990d70ae7073ca439" args="(const Matrix4 &amp;m2) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::operator *           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>m2</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Matrix concatenation using '*'. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00175">175</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="c1de0742f69e162e1ffc3a1aa18c3343"></a><!-- doxytag: member="Ogre::Matrix4::operator *" ref="c1de0742f69e162e1ffc3a1aa18c3343" args="(const Vector3 &amp;v) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> Ogre::Matrix4::operator *           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>v</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Vector transformation using '*'. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Transforms the given 3-D vector by the matrix, projecting the result back into <em>w</em> = 1. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This means that the initial <em>w</em> is considered to be 1.0, and then all the tree elements of the resulting 3-D vector are divided by the resulting <em>w</em>. </dd></dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00189">189</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::z</a>.</p>

</div>
</div><p>
<a class="anchor" name="95d402f87f878b8924a769dad7385156"></a><!-- doxytag: member="Ogre::Matrix4::operator *" ref="95d402f87f878b8924a769dad7385156" args="(const Vector4 &amp;v) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector4.html">Vector4</a> Ogre::Matrix4::operator *           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>v</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00201">201</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreVector4_8h-source.html#l00043">Ogre::Vector4::w</a>, <a class="el" href="OgreVector4_8h-source.html#l00043">Ogre::Vector4::x</a>, <a class="el" href="OgreVector4_8h-source.html#l00043">Ogre::Vector4::y</a>, and <a class="el" href="OgreVector4_8h-source.html#l00043">Ogre::Vector4::z</a>.</p>

</div>
</div><p>
<a class="anchor" name="d2374f86f6315aadbbe14ce743bc99e9"></a><!-- doxytag: member="Ogre::Matrix4::operator *" ref="d2374f86f6315aadbbe14ce743bc99e9" args="(const Plane &amp;p) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html">Plane</a> Ogre::Matrix4::operator *           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>p</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00210">210</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgrePlane_8h-source.html#l00135">Ogre::Plane::d</a>, <a class="el" href="OgrePlane_8h-source.html#l00134">Ogre::Plane::normal</a>, <a class="el" href="OgreVector3_8h-source.html#l00433">Ogre::Vector3::normalise()</a>, <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::z</a>.</p>

</div>
</div><p>
<a class="anchor" name="c0c54ddc64f9b832ab2656f514060fbb"></a><!-- doxytag: member="Ogre::Matrix4::operator+" ref="c0c54ddc64f9b832ab2656f514060fbb" args="(const Matrix4 &amp;m2) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::operator+           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>m2</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Matrix addition. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00227">227</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h-source.html#l00078">m</a>.</p>

</div>
</div><p>
<a class="anchor" name="6c698c19379d5b4d2ff6e5dd186ad76c"></a><!-- doxytag: member="Ogre::Matrix4::operator-" ref="6c698c19379d5b4d2ff6e5dd186ad76c" args="(const Matrix4 &amp;m2) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::operator-           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>m2</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Matrix subtraction. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00256">256</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h-source.html#l00078">m</a>.</p>

</div>
</div><p>
<a class="anchor" name="5eb73fdc4084eed850221ed14f558ff2"></a><!-- doxytag: member="Ogre::Matrix4::operator==" ref="5eb73fdc4084eed850221ed14f558ff2" args="(const Matrix4 &amp;m2) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::Matrix4::operator==           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>m2</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Tests 2 matrices for equality. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00284">284</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h-source.html#l00078">m</a>.</p>

</div>
</div><p>
<a class="anchor" name="67d3ae14b6b68e6824f1a91d99da16f8"></a><!-- doxytag: member="Ogre::Matrix4::operator!=" ref="67d3ae14b6b68e6824f1a91d99da16f8" args="(const Matrix4 &amp;m2) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::Matrix4::operator!=           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>m2</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Tests 2 matrices for inequality. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00297">297</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h-source.html#l00078">m</a>.</p>

</div>
</div><p>
<a class="anchor" name="5c5f37c501d49692728909d11dd8c1de"></a><!-- doxytag: member="Ogre::Matrix4::operator=" ref="5c5f37c501d49692728909d11dd8c1de" args="(const Matrix3 &amp;mat3)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::Matrix4::operator=           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>mat3</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Assignment from 3x3 matrix. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00310">310</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix3_8h-source.html#l00300">Ogre::Matrix3::m</a>.</p>

</div>
</div><p>
<a class="anchor" name="e141496dd80a027493cfc0bea3952a4d"></a><!-- doxytag: member="Ogre::Matrix4::transpose" ref="e141496dd80a027493cfc0bea3952a4d" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::transpose           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00317">317</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="af08a89733aa192a0d9e414e8b18ccf1"></a><!-- doxytag: member="Ogre::Matrix4::setTrans" ref="af08a89733aa192a0d9e414e8b18ccf1" args="(const Vector3 &amp;v)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::Matrix4::setTrans           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>v</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets the translation transformation part of the matrix. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00332">332</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::z</a>.</p>

</div>
</div><p>
<a class="anchor" name="928e9a44acf0f5a998392b272b117a4f"></a><!-- doxytag: member="Ogre::Matrix4::getTrans" ref="928e9a44acf0f5a998392b272b117a4f" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> Ogre::Matrix4::getTrans           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Extracts the translation transformation part of the matrix. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00341">341</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="fb53c4fa6548001260d77dc283e3652f"></a><!-- doxytag: member="Ogre::Matrix4::makeTrans" ref="fb53c4fa6548001260d77dc283e3652f" args="(const Vector3 &amp;v)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::Matrix4::makeTrans           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>v</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Builds a translation matrix. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00349">349</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::z</a>.</p>

</div>
</div><p>
<a class="anchor" name="87f478c5d19a10a371b736108e0b5e5f"></a><!-- doxytag: member="Ogre::Matrix4::makeTrans" ref="87f478c5d19a10a371b736108e0b5e5f" args="(Real tx, Real ty, Real tz)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::Matrix4::makeTrans           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>tx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>ty</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>tz</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00357">357</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="88fb90dffc0216a0a59bf19fad4eeace"></a><!-- doxytag: member="Ogre::Matrix4::getTrans" ref="88fb90dffc0216a0a59bf19fad4eeace" args="(const Vector3 &amp;v)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::getTrans           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>v</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets a translation matrix. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00367">367</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h-source.html#l00078">m</a>, <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::z</a>.</p>

</div>
</div><p>
<a class="anchor" name="3eedf9b0ea1245683a20f2e98ebd7e42"></a><!-- doxytag: member="Ogre::Matrix4::getTrans" ref="3eedf9b0ea1245683a20f2e98ebd7e42" args="(Real t_x, Real t_y, Real t_z)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::getTrans           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>t_x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>t_y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>t_z</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets a translation matrix - variation for not using a vector. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00381">381</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h-source.html#l00078">m</a>.</p>

</div>
</div><p>
<a class="anchor" name="754a168ea4d55d40c9a24ef33eb41c95"></a><!-- doxytag: member="Ogre::Matrix4::setScale" ref="754a168ea4d55d40c9a24ef33eb41c95" args="(const Vector3 &amp;v)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::Matrix4::setScale           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>v</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets the scale part of the matrix. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00400">400</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::z</a>.</p>

</div>
</div><p>
<a class="anchor" name="dfddc3e047c6052647ebfa5ddb3fbe13"></a><!-- doxytag: member="Ogre::Matrix4::getScale" ref="dfddc3e047c6052647ebfa5ddb3fbe13" args="(const Vector3 &amp;v)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::getScale           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>v</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets a scale matrix. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00409">409</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h-source.html#l00078">m</a>, <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::z</a>.</p>

</div>
</div><p>
<a class="anchor" name="5bac8a5777be6cf9af08c98de120d562"></a><!-- doxytag: member="Ogre::Matrix4::getScale" ref="5bac8a5777be6cf9af08c98de120d562" args="(Real s_x, Real s_y, Real s_z)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::getScale           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>s_x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>s_y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>s_z</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets a scale matrix - variation for not using a vector. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00422">422</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h-source.html#l00078">m</a>.</p>

</div>
</div><p>
<a class="anchor" name="7c32a3b5d7675181995e917f66c18b69"></a><!-- doxytag: member="Ogre::Matrix4::extract3x3Matrix" ref="7c32a3b5d7675181995e917f66c18b69" args="(Matrix3 &amp;m3x3) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::Matrix4::extract3x3Matrix           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Matrix3.html">Matrix3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>m3x3</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Extracts the rotation / scaling part of the Matrix as a 3x3 matrix. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>m3x3</em>&nbsp;</td><td>Destination <a class="el" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00436">436</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix3_8h-source.html#l00300">Ogre::Matrix3::m</a>.</p>

</div>
</div><p>
<a class="anchor" name="e66aaed3ab33c1f2a9862bc21dde0608"></a><!-- doxytag: member="Ogre::Matrix4::extractQuaternion" ref="e66aaed3ab33c1f2a9862bc21dde0608" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> Ogre::Matrix4::extractQuaternion           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Extracts the rotation / scaling part as a quaternion from the Matrix. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00452">452</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="1cbc315fd1f84a20c9a7d42e8f5db9da"></a><!-- doxytag: member="Ogre::Matrix4::operator *" ref="1cbc315fd1f84a20c9a7d42e8f5db9da" args="(Real scalar) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::operator *           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>scalar</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00465">465</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="2570c4903858248e80bc6f34571c141a"></a><!-- doxytag: member="Ogre::Matrix4::adjoint" ref="2570c4903858248e80bc6f34571c141a" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::adjoint           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="7e14122cbf6856b9701142cb6580aaa1"></a><!-- doxytag: member="Ogre::Matrix4::determinant" ref="7e14122cbf6856b9701142cb6580aaa1" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::Matrix4::determinant           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="8879acb17e3029cf8bc2796b29ed8470"></a><!-- doxytag: member="Ogre::Matrix4::inverse" ref="8879acb17e3029cf8bc2796b29ed8470" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::inverse           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="283bf568c924a673a1467c428d4b969d"></a><!-- doxytag: member="Ogre::Matrix4::makeTransform" ref="283bf568c924a673a1467c428d4b969d" args="(const Vector3 &amp;position, const Vector3 &amp;scale, const Quaternion &amp;orientation)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::Matrix4::makeTransform           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>position</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>scale</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>orientation</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Building a <a class="el" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a> from orientation / scale / position. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Transform is performed in the order scale, rotate, translation, i.e. translation is independent of orientation axes, scale does not affect size of translation, rotation and scaling are always centered on the origin. </dd></dl>

</div>
</div><p>
<a class="anchor" name="4e5949d1d1004070660f31036ee69523"></a><!-- doxytag: member="Ogre::Matrix4::makeInverseTransform" ref="4e5949d1d1004070660f31036ee69523" args="(const Vector3 &amp;position, const Vector3 &amp;scale, const Quaternion &amp;orientation)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::Matrix4::makeInverseTransform           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>position</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>scale</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>orientation</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Building an inverse <a class="el" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a> from orientation / scale / position. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>As makeTransform except it build the inverse given the same data as makeTransform, so performing -translation, -rotate, 1/scale in that order. </dd></dl>

</div>
</div><p>
<a class="anchor" name="582b20b912ed7d7f8f179505dfbe7a4e"></a><!-- doxytag: member="Ogre::Matrix4::isAffine" ref="582b20b912ed7d7f8f179505dfbe7a4e" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::Matrix4::isAffine           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Check whether or not the matrix is affine matrix. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>An affine matrix is a 4x4 matrix with row 3 equal to (0, 0, 0, 1), e.g. no projective coefficients. </dd></dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00517">517</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>Referenced by <a class="el" href="OgreMatrix4_8h-source.html#l00532">concatenateAffine()</a>, and <a class="el" href="OgreAxisAlignedBox_8h-source.html#l00495">Ogre::AxisAlignedBox::transformAffine()</a>.</p>

</div>
</div><p>
<a class="anchor" name="48cec18b03b16a9161d1c95b493a38a4"></a><!-- doxytag: member="Ogre::Matrix4::inverseAffine" ref="48cec18b03b16a9161d1c95b493a38a4" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::inverseAffine           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the inverse of the affine matrix. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>The matrix must be an affine matrix. </dd></dl>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Matrix4.html#582b20b912ed7d7f8f179505dfbe7a4e" title="Check whether or not the matrix is affine matrix.">Matrix4::isAffine</a>. </dd></dl>

</div>
</div><p>
<a class="anchor" name="854210ca8faa1380f447e552c1d34191"></a><!-- doxytag: member="Ogre::Matrix4::concatenateAffine" ref="854210ca8faa1380f447e552c1d34191" args="(const Matrix4 &amp;m2) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::Matrix4::concatenateAffine           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>m2</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Concatenate two affine matrix. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>The matrices must be affine matrix. </dd></dl>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Matrix4.html#582b20b912ed7d7f8f179505dfbe7a4e" title="Check whether or not the matrix is affine matrix.">Matrix4::isAffine</a>. </dd></dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00532">532</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreMatrix4_8h-source.html#l00517">isAffine()</a>, and <a class="el" href="OgreMatrix4_8h-source.html#l00078">m</a>.</p>

</div>
</div><p>
<a class="anchor" name="fcd6dae51beb8283338ad52ac63c86fb"></a><!-- doxytag: member="Ogre::Matrix4::transformAffine" ref="fcd6dae51beb8283338ad52ac63c86fb" args="(const Vector3 &amp;v) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> Ogre::Matrix4::transformAffine           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>v</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
3-D Vector transformation specially for affine matrix. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Transforms the given 3-D vector by the matrix, projecting the result back into <em>w</em> = 1. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>The matrix must be an affine matrix. </dd></dl>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Matrix4.html#582b20b912ed7d7f8f179505dfbe7a4e" title="Check whether or not the matrix is affine matrix.">Matrix4::isAffine</a>. </dd></dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00562">562</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::x</a>, <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::y</a>, and <a class="el" href="OgreVector3_8h-source.html#l00049">Ogre::Vector3::z</a>.</p>

<p>Referenced by <a class="el" href="OgreAxisAlignedBox_8h-source.html#l00495">Ogre::AxisAlignedBox::transformAffine()</a>.</p>

</div>
</div><p>
<a class="anchor" name="30bacec4331db3d61f8a43a0d8596595"></a><!-- doxytag: member="Ogre::Matrix4::transformAffine" ref="30bacec4331db3d61f8a43a0d8596595" args="(const Vector4 &amp;v) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector4.html">Vector4</a> Ogre::Matrix4::transformAffine           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>v</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
4-D Vector transformation specially for affine matrix. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>The matrix must be an affine matrix. </dd></dl>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Matrix4.html#582b20b912ed7d7f8f179505dfbe7a4e" title="Check whether or not the matrix is affine matrix.">Matrix4::isAffine</a>. </dd></dl>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00576">576</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>References <a class="el" href="OgreVector4_8h-source.html#l00043">Ogre::Vector4::w</a>, <a class="el" href="OgreVector4_8h-source.html#l00043">Ogre::Vector4::x</a>, <a class="el" href="OgreVector4_8h-source.html#l00043">Ogre::Vector4::y</a>, and <a class="el" href="OgreVector4_8h-source.html#l00043">Ogre::Vector4::z</a>.</p>

</div>
</div><p>
<hr><h2>Friends And Related Function Documentation</h2>
<a class="anchor" name="2adb0cd285959c5d2ef1c2e32937d1eb"></a><!-- doxytag: member="Ogre::Matrix4::operator&lt;&lt;" ref="2adb0cd285959c5d2ef1c2e32937d1eb" args="(std::ostream &amp;o, const Matrix4 &amp;m)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">_OgreExport friend std::ostream&amp; operator&lt;&lt;           </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&nbsp;</td>
          <td class="paramname"> <em>o</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>m</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Function for writing to a stream. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00477">477</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="949708616d61b1c520d04bd9b0577324"></a><!-- doxytag: member="Ogre::Matrix4::m" ref="949708616d61b1c520d04bd9b0577324" args="[4][4]" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Matrix4.html#949708616d61b1c520d04bd9b0577324">Ogre::Matrix4::m</a>[4][4]          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00078">78</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

<p>Referenced by <a class="el" href="OgreMatrix4_8h-source.html#l00147">concatenate()</a>, <a class="el" href="OgreMatrix4_8h-source.html#l00532">concatenateAffine()</a>, <a class="el" href="OgreMatrix4_8h-source.html#l00409">getScale()</a>, <a class="el" href="OgreMatrix4_8h-source.html#l00367">getTrans()</a>, <a class="el" href="OgreMatrix4_8h-source.html#l00297">operator!=()</a>, <a class="el" href="OgreMatrix4_8h-source.html#l00227">operator+()</a>, <a class="el" href="OgreMatrix4_8h-source.html#l00256">operator-()</a>, and <a class="el" href="OgreMatrix4_8h-source.html#l00284">operator==()</a>.</p>

</div>
</div><p>
<a class="anchor" name="0d9aaf75aa94b65f4ec5fe1afb0cf4d1"></a><!-- doxytag: member="Ogre::Matrix4::_m" ref="0d9aaf75aa94b65f4ec5fe1afb0cf4d1" args="[16]" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Matrix4.html#0d9aaf75aa94b65f4ec5fe1afb0cf4d1">Ogre::Matrix4::_m</a>[16]          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00079">79</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="64e62f0586dd8550fd6b0fa0b6d200b5"></a><!-- doxytag: member="Ogre::Matrix4::@6" ref="64e62f0586dd8550fd6b0fa0b6d200b5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">union { ... } <code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The matrix entries, indexed by [row][col]. 
<p>

</div>
</div><p>
<a class="anchor" name="838ac3cb744a01a39dfe35c61e942d7a"></a><!-- doxytag: member="Ogre::Matrix4::ZERO" ref="838ac3cb744a01a39dfe35c61e942d7a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#838ac3cb744a01a39dfe35c61e942d7a">Ogre::Matrix4::ZERO</a><code> [static]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00459">459</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="f2f61127dd1911c9ac2b4cbc0b4f3668"></a><!-- doxytag: member="Ogre::Matrix4::IDENTITY" ref="f2f61127dd1911c9ac2b4cbc0b4f3668" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#f2f61127dd1911c9ac2b4cbc0b4f3668">Ogre::Matrix4::IDENTITY</a><code> [static]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00460">460</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="08a798c0d8c8290dbc0287ca6561f549"></a><!-- doxytag: member="Ogre::Matrix4::CLIPSPACE2DTOIMAGESPACE" ref="08a798c0d8c8290dbc0287ca6561f549" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1Matrix4.html#08a798c0d8c8290dbc0287ca6561f549">Ogre::Matrix4::CLIPSPACE2DTOIMAGESPACE</a><code> [static]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Useful little matrix which takes 2D clipspace {-1, 1} to {0,1} and inverts the Y. 
<p>

<p>Definition at line <a class="el" href="OgreMatrix4_8h-source.html#l00463">463</a> of file <a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreMatrix4_8h-source.html">OgreMatrix4.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:50:33 2008
</p>
</body>
</html>
